import os
import subprocess
from charmhelpers.core import host
from charmhelpers.core import hookenv


__all__ = ['CF_DIR', 'CC_PACKAGES', 'CC_DIR', 'CC_CONFIG_DIR',
           'CC_CONFIG_FILE', 'CC_DB_FILE', 'CC_JOB_FILE',
           'CC_LOG_DIR', 'CC_RUN_DIR',
           'NGINX_JOB_FILE', 'NGINX_CONFIG_FILE',
           'NGINX_RUN_DIR', 'NGINX_LOG_DIR', 'FOG_CONNECTION']

CC_PACKAGES = ['cfcloudcontroller', 'runit', 'golang-go', 'python-jinja2']
CF_DIR = '/var/lib/cloudfoundry'
CC_DIR = os.path.join(CF_DIR, 'cfcloudcontroller')
CC_CONFIG_DIR = os.path.join(CC_DIR, 'config')
# this one goes from package
CC_CONFIG_FILE = os.path.join(CC_CONFIG_DIR, 'cloud_controller.yml')
CC_DB_FILE = os.path.join(CC_DIR, 'db/cc.db')
CC_JOB_FILE = '/etc/init/cf-cloudcontroller.conf'
CC_LOG_DIR = '/var/vcap/sys/log/cloud_controller_ng'
CC_RUN_DIR = '/var/vcap/sys/run/cloud_controller_ng'

NGINX_JOB_FILE = '/etc/init/cf-nginx.conf'
NGINX_CONFIG_FILE = os.path.join(CC_CONFIG_DIR, 'nginx.conf')
NGINX_RUN_DIR = '/var/vcap/sys/run/nginx_ccng'
NGINX_LOG_DIR = '/var/vcap/sys/log/nginx_ccng'
FOG_CONNECTION = '/var/vcap/nfs/store'


def db_migrate():
    hookenv.log("Starting db:migrate...", hookenv.DEBUG)
    with host.chdir(CC_DIR) as dir:
        #TODO: make it idempotent by deleting existing db if exists
        subprocess.check_call([
            'sudo', '-u', 'vcap', '-g', 'vcap',
            'CLOUD_CONTROLLER_NG_CONFIG={}'.format(CC_CONFIG_FILE),
            'bundle', 'exec', 'rake', 'db:migrate'])
        hookenv.log("Finished db:migrate in %s." % (dir))
